import java.awt.Graphics;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

public class SmileyPanel extends JPanel
{
    private ImageIcon icon;
    private int x;
    private int y;
    
    public SmileyPanel()
    {
        icon = new ImageIcon("smiley.png");
        x = 300;
        y = 200;
        // This panel can accept key presses / mice clicks
        this.setFocusable(true); 
        
        this.addKeyListener(new KeyAdapter() {

            
            @Override
            public void keyTyped(KeyEvent e)
            {
                char c = e.getKeyChar();
                switch(c) 
                {
                    case 'j':
                        x -= 5;
                        // Left
                        SmileyPanel.this.repaint();
                        break;
                    case 'k':
                        // Right
                        x += 5;
                        SmileyPanel.this.repaint();
                        break;
                        
                }
                
            }
            
        });
        
        this.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e)
            {
                x = e.getX();
                y = e.getY();
                SmileyPanel.this.repaint();
            }
        });
        
        this.addMouseMotionListener(new MouseAdapter() {
            public void mouseMoved(MouseEvent e)
            {
                x = e.getX();
                y = e.getY();
                SmileyPanel.this.repaint();
            }
        });
    }
    
    protected void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        
        icon.paintIcon(this , g , x , y);
    }
}
